## pcb-rnd 2.2.0

=== Makefile ===
all: FORCE
	cd src_3rd/puplug/util && $(MAKE) CC=$(PCB_RND_HOST_CC)
	cd src && $(MAKE)
	cd util && $(MAKE)
	cd pcblib && $(MAKE)
#	cd doc && $(MAKE)

test: FORCE
	cd tests && $(MAKE) test

clean: FORCE
	cd src && $(MAKE) clean
	cd util && $(MAKE) clean
	cd pcblib && $(MAKE) clean
#	cd doc && $(MAKE) clean
	cd tests && $(MAKE) clean
	cd src_3rd/sphash && $(MAKE) clean
	cd src_3rd/puplug && $(MAKE) clean
	cd src_3rd/libminuid && $(MAKE) clean ; true
	cd src_3rd/libuundo && $(MAKE) clean ; true

# Note: have to distclean utils (and tests) before src because of hidlib deps
distclean: FORCE
	$(MAKE) clean ; true
#	cd doc && $(MAKE) distclean
	cd util/gsch2pcb-rnd && $(MAKE) distclean
	cd src && $(MAKE) distclean
	cd src_3rd/genlist && $(MAKE) clean ; true
	cd src_3rd/genregex && $(MAKE) clean ; true
	cd src_3rd/genvector && $(MAKE) clean ; true
	cd src_3rd/liblihata && $(MAKE) clean ; true
	cd src_3rd/liblihata/genht && $(MAKE) clean ; true
	cd src_3rd/qparse && $(MAKE) clean ; true
	cd scconfig && $(MAKE) distclean ; true


install: FORCE
	cd src && $(MAKE) install
	cd util && $(MAKE) install
	cd pcblib && $(MAKE) install
	cd doc && $(MAKE) install

linstall: FORCE
	cd src && $(MAKE) linstall
	cd util && $(MAKE) linstall
	cd pcblib && $(MAKE) linstall
	cd doc && $(MAKE) linstall

uninstall: FORCE
	cd src && $(MAKE) uninstall
	cd util && $(MAKE) uninstall
	cd pcblib && $(MAKE) uninstall
	cd doc && $(MAKE) uninstall

include Makefile.conf

FORCE:

=== data/Makefile ===
# This Makefile is a plain old hand written one; all configuration settings
# are included from ../Makefile.conf which is scconfig generated

theme = hicolor

app_icon = pcb

mime_icons = \
	application-x-pcb-layout \
	application-x-pcb-footprint \
	application-x-pcb-netlist \
	application-x-gerber \
	application-x-excellon

app_icon_files = \
	$(app_icon:%=%-48.png) \
	$(app_icon:%=%.svg)
#	$(app_icon:%=%-16.png)
#	$(app_icon:%=%-22.png)
#	$(app_icon:%=%-24.png)
#	$(app_icon:%=%-32.png)

mime_icon_files = \
	$(mime_icons:%=%-16.png) \
	$(mime_icons:%=%-22.png) \
	$(mime_icons:%=%-24.png) \
	$(mime_icons:%=%-32.png) \
	$(mime_icons:%=%-48.png) \
	$(mime_icons:%=%.svg)

mime_icon_sources = \
	$(mime_icons:%=%-16.svg) \
	$(mime_icons:%=%-22.svg) \
	$(mime_icons:%=%-32.svg) \
	$(mime_icons:%=%-48.svg)

theme_icons = \
	$(mime_icon_files:%=mimetypes,%) \
	$(app_icon_files:%=apps,%)

all:

install_:
	./icon-theme-installer \
		-t $(theme) \
		-m "$(MKDIR)" \
		-s `pwd` \
		-d x \
		-b "$(themedir)" \
		-x "$(CPC)" \
		-i $(theme_icons)

install:
	$(MAKE) install_ CPC="$(CP)"

linstall:
	$(MAKE) install_ CPC="$(LN)"

uninstall:
	$(RM) $(DOCDIR)/examples/tut1.pcb

include ../Makefile.conf
themedir=$(DATADIR)/icons/$(theme)

=== pcblib/Makefile ===
# This Makefile is a plain old hand written one; all configuration settings
# are included from ../Makefile.conf which is scconfig generated

ROOT=..

all:

# NOTE: this rule is _not_ called from linstall
install_:
	$(MKDIR) "$(DATADIR)/pcblib"
	$(MKDIR) "$(DATADIR)/pcblib/connector"
	$(CPC) "`pwd`/connector"/* "$(DATADIR)/pcblib/connector"
	$(MKDIR) "$(DATADIR)/pcblib/parametric"
	$(CPC) "`pwd`/parametric"/* "$(DATADIR)/pcblib/parametric"
	$(MKDIR) "$(DATADIR)/pcblib/smd"
	$(CPC) "`pwd`/smd"/* "$(DATADIR)/pcblib/smd"
	$(MKDIR) "$(DATADIR)/pcblib/tru-hole"
	$(CPC) "`pwd`/tru-hole"/* "$(DATADIR)/pcblib/tru-hole"

install:
	$(MAKE) install_ CPC="$(CP)"

# hack: pcb's chdir() based approach gets fooled on symlinks because of "cd .."
# returns to the wrong dir - rather symlink the whole dir
linstall:
	$(MAKE) uninstall
	$(MKDIR) "$(DATADIR)"
	$(LN) "`pwd`" "$(DATADIR)/pcblib"

uninstall:
	$(RM) "$(DATADIR)/pcblib"

clean:

include $(ROOT)/Makefile.conf

=== scconfig/Makefile ===
# --- configuration part --

# - generic configuration -
SRC=src
BIN=src

#  what cflags to use to compile scconfig
USER_CFLAGS = -DGENCALL -Isrc
#USER_CFLAGS = -Wall -Wextra -g -DGENCALL -Isrc

#  what ldflags to use to link scconfig
USER_LDFLAGS =

#  in case hooks.c needs to link to something local
USER_OBJS = src/util/arg_auto_set.o

#  what to build - a ./configure
all: configure cquote

# This line imports scconfig core and default tests
include src/default/Makefile.plugin

#
# - PLUGINS -
#
#  Comment this line if you are not interested in c99 features
include src/c99/Makefile.plugin

#  Comment this line if you do not need script libs to be detected
include src/scripts/Makefile.plugin

#  Comment this line if you do not need parser libs to be detected
# include src/parser/Makefile.plugin

#  Comment this line if you do not need to detect parser generators
include src/parsgen/Makefile.plugin

#  Comment this line if you do not need math related libs
include src/math/Makefile.plugin

#  Comment this line if you do not need socket/networking
include src/socket/Makefile.plugin

#  Comment this line if you do not need user/password API detection
include src/userpass/Makefile.plugin

#  Comment this line if you do not need gui (X11, toolkits)
include src/gui/Makefile.plugin

#  Comment this line if you do not need software utility libs (glib)
include src/sul/Makefile.plugin

#  Uncomment this line if you need menus
include src/menulib/Makefile.plugin

#  Comment this line if you do not need generator (templating)
#include src/generator/Makefile.plugin

#  Comment this line if you do not need tmpasm (templating); conflicts with generator
include src/tmpasm/Makefile.plugin

# --- you shouldn't edit the lines below ---
OBJS = $(USER_OBJS) hooks.o $(DEFAULT_NOMAIN_OBJS) $(SCRIPT_OBJS) $(PARSER_OBJS) $(GENERATOR_OBJS) $(TMPASM_OBJS) $(C99_OBJS) $(PARSGEN_OBJS) $(MATH_OBJS) $(SOCKET_OBJS) $(USERPASS_OBJS) $(GUI_OBJS) $(SUL_OBJS)
CFLAGS = $(USER_CFLAGS) $(DEFAULT_CFLAGS) $(SCRIPT_CFLAGS) $(PARSER_CFLAGS) $(GENERATOR_CFLAGS) $(TMPASM_CFLAGS) $(C99_CFLAGS) $(PARSGEN_CFLAGS) $(MATH_CFLAGS) $(SOCKET_CFLAGS) $(USERPASS_CFLAGS) $(GUI_CFLAGS)  $(SUL_CFLAGS) $(MENULIB_CFLAGS) -Isrc/default
LDFLAGS = $(USER_LDFLAGS) $(DEFAULT_LDFLAGS) $(SCRIPT_LDFLAGS) $(PARSER_LDFLAGS) $(GENERATOR_LDFLAGS) $(TMPASM_LDFLAGS) $(C99_LDFLAGS) $(PARSGEN_LDFLAGS) $(MATH_LDFLAGS) $(SOCKET_LDFLAGS) $(USERPASS_LDFLAGS) $(GUI_LDFLAGS) $(SUL_LDFLAGS) $(MENULIB_LDFLAGS)

all: configure revtest sccbox

revtest: revtest.o
	$(CC) -o revtest revtest.o

revtest.o: revtest.c  Rev.h
	$(CC) -c $(CFLAGS) -o revtest.o revtest.c

configure: $(OBJS)  $(DEFAULT_MAIN_OBJS)
	$(CC) -o configure $(OBJS)  $(DEFAULT_MAIN_OBJS)

menuconfig: menucfg
	./menucfg

menucfg: $(OBJS) $(MENULIB_OBJS) src/default/main_lib.o src/default/main_custom_args.o menucfg.o src/util/arg_auto_menu.o src/util/arg_auto_set.o
	$(CC) -o menucfg $(OBJS) $(MENULIB_OBJS) menucfg.o src/default/main_lib.o src/default/main_custom_args.o src/util/arg_auto_menu.o

menucfg.o: menucfg.c
	$(CC) -c $(CFLAGS) -o menucfg.o menucfg.c

hooks.o: plugin_3state.h plugins.h Rev.h ../src_3rd/puplug/scconfig_hooks.h ../src_3rd/libfungw/scconfig_hooks.h

src/util/arg_auto_set.o: src/util/arg_auto_set.c src/util/arg_auto_set.h
	$(CC) -c $(CFLAGS) -o src/util/arg_auto_set.o src/util/arg_auto_set.c

src/util/sccbox.o: src/util/sccbox.c
	$(CC) -c $(CFLAGS) -o src/util/sccbox.o src/util/sccbox.c

sccbox: src/util/sccbox.o
	$(CC) $(LDFLAGS) -o sccbox src/util/sccbox.o

cquote: src/util/cquote.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o cquote src/util/cquote.c

clean:
	-rm $(OBJS) $(DEFAULT_MAIN_OBJS) configure revtest revtest.o cquote core src/util/sccbox.o

distclean:
	-rm ../config.h ../Makefile.conf ../src/Makefile ../util/gsch2pcb-rnd/Makefile config.cache config.log Rev.stamp sccbox gmon.out ../src_3rd/puplug/Makefile ../src_3rd/puplug/config.h ../src_plugins/lib_hid_gl/opengl.h
	-$(MAKE) clean

=== tests/Makefile ===
test:
	cd RTT && $(MAKE) all && $(MAKE) test
	cd pcbflags && $(MAKE) all && $(MAKE) test
	cd conf && $(MAKE) all && $(MAKE) test
	cd strflags && $(MAKE) all && $(MAKE) test
	cd pcb-printf && $(MAKE) all && $(MAKE) test
	cd uniq_name && $(MAKE) all && $(MAKE) test
	cd propedit && $(MAKE) all && $(MAKE) test
	cd remote && $(MAKE) all && $(MAKE) test
	cd drc_pstk_hbrk && $(MAKE) all && $(MAKE) test
# This uses make instead of $(MAKE) on purpose as a "portbale" -j1 to work aroudn GNU make
	cd librnd && make all && make test
#	cd gsch2pcb-rnd && $(MAKE) all && $(MAKE) test
	@echo " "
	@echo "+-------------------------------------------------+"
	@echo "+  All tests passed, pcb-rnd is safe to install.  +"
	@echo "+-------------------------------------------------+"

clean:
	cd RTT && $(MAKE) clean
	cd pcbflags && $(MAKE) clean
	cd conf && $(MAKE) clean
	cd strflags && $(MAKE) clean
	cd pcb-printf && $(MAKE) clean
	cd uniq_name && $(MAKE) clean
	cd propedit && $(MAKE) clean
	cd remote && $(MAKE) clean
	cd drc_pstk_hbrk && $(MAKE) clean
	cd librnd && $(MAKE) clean
#	cd gsch2pcb-rnd && $(MAKE) clean

=== util/Makefile ===
# plain old hand crafted Makefile
ROOT=..

all:
	cd gsch2pcb-rnd && $(MAKE) all

include $(ROOT)/Makefile.conf

clean:
	cd gsch2pcb-rnd && $(MAKE) clean

distclean:
	cd gsch2pcb-rnd && $(MAKE) distclean

install_all:
	$(SCCBOX) mkdir -p  "$(BINDIR)" "$(LIBDIR)"
	$(SCCBOX) $(HOW) "fp2preview" "$(BINDIR)/fp2preview"
	$(SCCBOX) $(HOW) "fp2subc" "$(BINDIR)/fp2subc"
	$(SCCBOX) $(HOW) "pcb-strip" "$(BINDIR)/pcb-strip"
	$(SCCBOX) $(HOW) "pcb-prj2lht" "$(BINDIR)/pcb-prj2lht"
	$(SCCBOX) $(HOW) "gnet-pcbrndfwd.scm" "$(LIBDIR)/gnet-pcbrndfwd.scm"
	$(SCCBOX) $(HOW) "gnet-pcbrndfwd_elem.scm" "$(LIBDIR)/gnet-pcbrndfwd_elem.scm"

install:
	$(MAKE) install_all HOW="install -f"
	cd gsch2pcb-rnd && $(MAKE) install

linstall:
	$(MAKE) install_all HOW="linstall -f"
	cd gsch2pcb-rnd && $(MAKE) linstall

uninstall:
	$(MAKE) install_all HOW="uninstall"
	cd gsch2pcb-rnd && $(MAKE) uninstall

=== doc/developer/Makefile ===
ROOT=../..
DEVDIR=$(DOCDIR)/developer

all:

install_all:
	$(SCCBOX) mkdir -p $(DEVDIR)/alien_formats $(DEVDIR)/ddrc $(DEVDIR)/hid_remote $(DEVDIR)/mods3
	$(SCCBOX) $(HOW) alien_formats/*.txt $(DEVDIR)/alien_formats/
	$(SCCBOX) $(HOW) ddrc/*.txt $(DEVDIR)/ddrc/
	$(SCCBOX) $(HOW) hid_remote/*.html hid_remote/*.svg $(DEVDIR)/hid_remote/
	$(SCCBOX) $(HOW) mods3/*.html mods3/*.png $(DEVDIR)/mods3/

install:
	$(MAKE) install_all HOW="install -f -d"

linstall:
	$(MAKE) install_all HOW="install -f -l -d"

uninstall:
	$(MAKE) install_all HOW="install -u"

clean:

distclean:


include $(ROOT)/Makefile.conf

=== doc/man/Makefile ===
# This Makefile is a plain old hand written one; all configuration settings
# are included from $(ROOT)/Makefile.conf which is scconfig generated
ROOT=../..

IN=pcb-rnd.1.mml pcb-strip.1.mml pcb-prj2lht.1.mml fp2preview.1.mml fp2subc.1.mml
OUT_HTML = pcb-rnd.1.html pcb-strip.1.html pcb-prj2lht.1.html fp2preview.1.html fp2subc.1.html
OUT_MAN1 = pcb-rnd.1 pcb-strip.1 pcb-prj2lht.1 fp2preview.1  fp2subc.1
OUT_LINT = pcb-rnd.1.lint pcb-strip.1.lint pcb-prj2lht.1.lint fp2preview.1.lint fp2subc.1.lint

OUTPUT = $(OUT_HTML) $(OUT_MAN1) index.html
MML = /usr/bin/mml

all: $(OUTPUT)

lint: $(OUT_LINT)

.SUFFIXES: .html .mml .lint

.mml.html: .mml_linkmap
	$(MML) -i copyright.mml -f html $<  > $@

.mml:
	$(MML) -i copyright.mml -f man $<  > $@

.mml_linkmap:
	$(MML) -i copyright.mml -f linkmap $(IN) > $@

index.html: $(IN)
	@echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">' > $@
	@echo '<HTML><HEAD><meta http-equiv="Content-Type" content="text/html;charset=us-ascii"><TITLE>man page index - pcb-rnd</TITLE></HEAD><BODY><UL>' >> $@
	$(MML) -i copyright.mml -f indexhtml $(IN) >> $@
	@echo "</UL></BODY></HTML>" >> $@

clean:

distclean:

genclean:
	rm $(OUTPUT) 2>/dev/null ; true

.mml.lint:
	$(MML) -i copyright.mml -f lint $<

install_all:
	$(SCCBOX) mkdir -p "$(MAN1DIR)"
	$(SCCBOX) $(HOW) "pcb-rnd.1" "$(MAN1DIR)/pcb-rnd.1"
	$(SCCBOX) $(HOW) "pcb-strip.1" "$(MAN1DIR)/pcb-strip.1"
	$(SCCBOX) $(HOW) "pcb-prj2lht.1" "$(MAN1DIR)/pcb-prj2lht.1"
	$(SCCBOX) $(HOW) "gsch2pcb-rnd.1" "$(MAN1DIR)/gsch2pcb-rnd.1"
	$(SCCBOX) $(HOW) "fp2preview.1" "$(MAN1DIR)/fp2preview.1"
	$(SCCBOX) $(HOW) "fp2subc.1" "$(MAN1DIR)/fp2subc.1"

install:
	$(MAKE) install_all HOW="install -f"

linstall:
	$(MAKE) install_all HOW="linstall -f"

uninstall:
	$(MAKE) install_all HOW="uninstall"

include $(ROOT)/Makefile.conf

=== doc/user/Makefile ===
ROOT=../..
BUILD=$(ROOT)/util/build_ps.sh
USERDIR=$(DOCDIR)/user

INSTD = 02_model 03_data 04_invoc 05_ui 06_feature 07_io \
        08_util 09_appendix

all: user.pdf

user.ps: ps.lst $(BUILD) default.css Makefile
	HTML2PS_OPTS="-f default.css" HTML2PS_SED="s^<[hH]1>.*</[hH]1>^^g" $(BUILD) `cat ps.lst` > user.ps

user.pdf: user.ps
	ps2pdf user.ps

ps.lst: */*.html */*.png
	echo "title.html" > ps.lst
	echo "index.html" >> ps.lst
	ls */*.html | sort >> ps.lst

include Makefile.inst

regen: instgen
	./instgen

install:
	$(MAKE) install_all HOW="install -f"

linstall:
	$(MAKE) install_all HOW="install -f -l --absolute "

uninstall:
	$(MAKE) install_all HOW="install -u"

include $(ROOT)/Makefile.conf

=== src_3rd/genht/Makefile ===
# use -DGENHT_WANT_INLINE to turn half of the API into static inline functions
PREFIX=/usr
INCDIR=$(install_root)$(DESTDIR)$(PREFIX)/include/genht
LIBDIR=$(install_root)$(DESTDIR)$(PREFIX)/lib

HOSTCC = $(CC)

VER_MAJOR=1
VER_MINOR=1
VER_PATCH=1
VER=$(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)

CFLAGS=-g $(GENHT_CFLAGS)
LDFLAGS=$(GENHT_LDFLAGS)

BIN=mainsi
OBJS=htss.o htsp.o htsi.o htip.o htpp.o htpi.o hash.o siphash24.o
LIBSO=libgenht.so.$(VER)
LIBSO1=libgenht.so.$(VER_MAJOR)
LIBA=libgenht.a

all: version.h $(BIN) $(OBJS) $(LIBA) $(LIBSO)

clean:
	-rm $(BIN) $(OBJS) $(LIBA) $(LIBSO) genht_std.so genht_std.a

.SUFFIXES:
.SUFFIXES: .o .c

.c.o:
	$(CC) -o $@ -c -fPIC $< $(CFLAGS)

mainsi: mainsi.o htsi.o
	$(CC) -o $@ mainsi.o htsi.o $(LDFLAGS)

$(LIBSO): $(OBJS)
	$(CC) $(LDFLAGS) -shared -dynamic -rdynamic -o $@ $(OBJS)

$(LIBA): $(OBJS)
	ar rvu $@ $(OBJS)

# for compatibility
genht_std.so: $(LIBSO)
	ln -s $(LIBSO) genht_std.so

# for compatibility
genht_std.a: $(LIBA)
	ln -s $(LIBA) genht_std.a

version.h: version.h.in ver_edit
	./ver_edit $(VER_MAJOR) $(VER_MINOR) $(VER_PATCH) < version.h.in > version.h

ver_edit: ver_edit.c
	$(HOSTCC) -o $@ $(CFLAGS) ver_edit.c

install_:
	mkdir -p $(INCDIR) $(LIBDIR)
	$(CP) `pwd`/hash.h $(INCDIR)/hash.h
	$(CP) `pwd`/ht.h $(INCDIR)/ht.h
	$(CP) `pwd`/version.h $(INCDIR)/version.h
	$(CP) `pwd`/ht_inlines.h $(INCDIR)/ht_inlines.h
	$(CP) `pwd`/htip.h $(INCDIR)/htip.h
	$(CP) `pwd`/htsi.h $(INCDIR)/htsi.h
	$(CP) `pwd`/htsp.h $(INCDIR)/htsp.h
	$(CP) `pwd`/htss.h $(INCDIR)/htss.h
	$(CP) `pwd`/htpp.h $(INCDIR)/htpp.h
	$(CP) `pwd`/$(LIBSO) $(LIBDIR)/$(LIBSO)
	$(CP) `pwd`/$(LIBA) $(LIBDIR)/$(LIBA)

uninstall:
	rm -rf $(INCDIR)
	rm $(LIBDIR)/$(LIBSO) $(LIBDIR)/$(LIBA) $(LIBDIR)/$(LIBSO1)

install:
	make install_ CP="cp"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

linstall:
	make install_ CP="ln -s"
	-@rm $(LIBDIR)/$(LIBSO1) 2>/dev/null
	ln -s $(LIBSO) $(LIBDIR)/$(LIBSO1)

=== src_3rd/genvector/Makefile ===
#CFLAGS = -I.. -O3 -Wall -ansi -pedantic
CFLAGS = -I.. -g $(GENVECTOR_CFLAGS)
LDFLAGS = $(GENVECTOR_LDFLAGS)
OBJS = gds_char.o gds_wchar.o vti0.o vts0.o vtp0.o vtii.o vti0.o vtd0.o
IMPL = genvector_impl.c genvector_impl.h genvector_undef.h

LIBA = libgenvector.a

all: $(LIBA)

$(LIBA): $(OBJS)
	ar ur $(LIBA) $(OBJS)

gds_char.o: gds_char.c gds_char.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

gds_wchar.o: gds_wchar.c gds_wchar.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vti0.o: vti0.c vti0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vtd0.o: vtd0.c vtd0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vts0.o: vts0.c vts0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vtp0.o: vtp0.c vtp0.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

vtii.o: vtii.c vtii.h $(IMPL)
	$(CC) -c $(CFLAGS) $*.c -o $@

clean:
	rm $(OBJS) $(LIBA) 2>/dev/null ; true

include ../Makefile.conf

install_:
	mkdir -p "$(INCDIR)" "$(LIBDIR)"
	$(CP) "$(PWD)/gds_char.h" "$(INCDIR)/gds_char.h"
	$(CP) "$(PWD)/gds_wchar.h" "$(INCDIR)/gds_wchar.h"
	$(CP) "$(PWD)/genvector_impl.h" "$(INCDIR)/genvector_impl.h"
	$(CP) "$(PWD)/genvector_undef.h" "$(INCDIR)/genvector_undef.h"
	$(CP) "$(PWD)/vti0.h" "$(INCDIR)/vti0.h"
	$(CP) "$(PWD)/vtii.h" "$(INCDIR)/vtii.h"
	$(CP) "$(PWD)/$(LIBA)" "$(LIBDIR)/$(LIBA)"

uninstall:
	rm $(LIBDIR)/$(LIBA)
	rm $(INCDIR)/gds_*.h $(INCDIR)/genvector*.h $(INCDIR)/vt*.h

install:
	make install_ CP="cp" PWD=`pwd`

linstall:
	make install_ CP="ln -s" PWD=`pwd`

=== src_3rd/liblihata/Makefile ===
ROOT=..
CFLAGS = -Wall -g -I.. $(LIHATA_CFLAGS)
OBJS_PARSER = parser.o lihata.o
OBJS_DOM = hash_str.o dom.o dom_hash.o dom_list.o dom_table.o
OBJS_TREE = tree.o tree_list.o tree_hash.o tree_table.o tree_path.o tree_symlink.o
OBJS = test_parser.o test_dom.o test_tree.o  $(OBJS_PARSER) $(OBJS_DOM) $(OBJS_TREE)
TESTERS = test_parser test_dom test_tree
LIBS = liblihata.a
include $(ROOT)/Makefile.conf
LDLIBS=$(LIBGENHT)


all: $(TESTERS) $(LIBS)

test_parser: test_parser.o $(OBJS_PARSER) $(LIBGENHT_DEP)
	$(CC) $(LDFLAGS) test_parser.o $(OBJS_PARSER) $(LDLIBS) -o $@

test_dom: test_dom.o $(OBJS_DOM) $(OBJS_PARSER) $(LIBGENHT_DEP)
	$(CC) $(LDFLAGS) test_dom.o $(OBJS_DOM) $(OBJS_PARSER) $(LDLIBS) -o $@

test_tree: test_tree.o $(OBJS_TREE) $(OBJS_DOM) $(OBJS_PARSER) $(LIBGENHT_DEP)
	$(CC) $(LDFLAGS) test_tree.o $(OBJS_TREE) $(OBJS_DOM) $(OBJS_PARSER) $(LDLIBS) -o $@

liblihata.a: $(OBJS_DOM) $(OBJS_PARSER) $(OBJS_TREE)
	ar rvu $@ $(OBJS_DOM) $(OBJS_PARSER) $(OBJS_TREE)
	ranlib $@

../genht/htsp.o:
	$(CC) $(CFLAGS) -c ../genht/htsp.c -o ../genht/htsp.o

# dependencies

include Makefile.dep

depend:
	@echo "# Generated by \"make depend\"" > Makefile.dep
	gcc $(CFLAGS) -MM `echo $(OBJS) | sed "s/\.o/.c/g"` | sed "s/^htsp.o.*//; s%[.][.]/genht/[a-zA-Z0-9_]*[.][hoc]%%g" >> Makefile.dep

ns: liblihata.a
	@echo Namespace pollution in objects:
	@nm liblihata.a | awk '/ [ABCDGNRSTVW] / { if (($$(NF) ~ "^lht_") || ($$(NF) ~ "^hts._")) next; print $$0}'

test:
	cd regression && make

clean:
	-rm $(OBJS) $(TESTERS) $(LIBS) 2>/dev/null

dist-clean: clean

install_:
	mkdir -p $(LIBDIR) $(INCDIR)
	$(CP) $(PWD)/liblihata.a $(LIBDIR)/liblihata.a
	$(CP) $(PWD)/dom.h $(INCDIR)/dom.h
	$(CP) $(PWD)/hash_str.h $(INCDIR)/hash_str.h
	$(CP) $(PWD)/lihata.h $(INCDIR)/lihata.h
	$(CP) $(PWD)/parser.h $(INCDIR)/parser.h
	$(CP) $(PWD)/tree.h $(INCDIR)/tree.h

uninstall:
	rm $(LIBDIR)/liblihata.a
	rm -rf $(INCDIR)

install:
	make install_ CP="cp" PWD=`pwd`

linstall:
	make install_ CP="ln -sf" PWD=`pwd`

include $(ROOT)/Makefile.common

=== debian/changelog ===
pcb-rnd (2.2.0-3) unstable; urgency=medium

  * fix from upstream to include pcblib (footprint lib) in pcb-rnd-core

 -- Bdale Garbee <bdale@gag.com>  Wed, 26 Feb 2020 22:16:46 -0700

pcb-rnd (2.2.0-2) unstable; urgency=medium

  * move restructured packaging from experimental to unstable

 -- Bdale Garbee <bdale@gag.com>  Mon, 24 Feb 2020 18:33:31 -0700

pcb-rnd (2.2.0-2~exp3) experimental; urgency=medium

  * pcb-rnd-core and pcb-rnd-import-net also needs Replaces 

 -- Bdale Garbee <bdale@gag.com>  Wed, 19 Feb 2020 01:07:33 -0700

pcb-rnd (2.2.0-2~exp2) experimental; urgency=medium

  * mark pcb-rnd-doc with Replaces on pre-split pcb-rnd to prevent failure
    from attempted file overwrites during install on upgrade

 -- Bdale Garbee <bdale@gag.com>  Tue, 18 Feb 2020 11:56:41 -0700

pcb-rnd (2.2.0-2~exp1) experimental; urgency=medium

  * restructure packaging to use a modular approach favored by upstream
  * target experimental for now
  * make -dev package dependency on shared lib version stronger

 -- Bdale Garbee <bdale@gag.com>  Mon, 10 Feb 2020 23:46:08 -0700

pcb-rnd (2.2.0-1) unstable; urgency=medium

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Fri, 24 Jan 2020 02:42:02 -0700

pcb-rnd (2.1.4-2) unstable; urgency=medium

  * patch from upstream to fix non-relative library symlinks, closes: #943955

 -- Bdale Garbee <bdale@gag.com>  Tue, 05 Nov 2019 22:22:25 -0700

pcb-rnd (2.1.4-1) unstable; urgency=medium

  * new upstream release

 -- Bdale Garbee <bdale@gag.com>  Tue, 29 Oct 2019 22:17:22 -0600

=== debian/control ===
Source: pcb-rnd
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>, Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>= 11), gettext, imagemagick, libgd-dev, libgtkglext1-dev, libmotif-dev, libstroke0-dev, libxml2-dev
Standards-Version: 4.1.3
Homepage: http://repo.hu/projects/pcb-rnd
Vcs-Git: https://salsa.debian.org/electronics-team/pcb-rnd.git
Vcs-Browser: https://salsa.debian.org/electronics-team/pcb-rnd

Package: pcb-rnd
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-io-standard, pcb-rnd-io-alien, pcb-rnd-hid-gtk2-gl, pcb-rnd-hid-gtk2-gdk, pcb-rnd-export, pcb-rnd-export-sim, pcb-rnd-export-extra, pcb-rnd-auto, pcb-rnd-extra, pcb-rnd-cloud, pcb-rnd-doc, pcb-rnd-import-net
Suggests: geda-gnetlist
Description: Standard installation of pcb-rnd
 pcb-rnd is a highly modular PCB (Printed Circuit Board) layout tool
 with a rich set of plugins for communicating with various external
 design tools and other EDA/CAD packages.
 .
 Feature highlights:
   - subcircuits, pad stacks
   - flexible footprint model; unrestricted pad shapes
   - arbitrary copper, silk, paste and soldermask objects
   - sophisticated, flexible layer model
   - flexible/universal polygon model
   - any object, even polygons, can have a clearance within a polygon
   - advanced mil and mm grid, with support for mixed unit design
   - strong CLI support
   - static footprints and parametric (generated) footprints
   - query language for advanced search & select
   - layout optimizers such as teardrops and a trace puller
   - footprint library from local file systems, HTTP and board files
   - netlist management: imported and as-built; back annotation
   - design rule checker
 .
 File formats and compatibility:
   - text based, tree structured native file format
   - gerber (export)
   - KiCad, s-expr format boards (read, write)
   - KiCad, s-expr format elements (write)
   - KiCad, legacy text format boards (write)
   - KiCad, eeschema netlist+footprint info (import)
   - tEDAx footprints (read, write)
   - tEDAx netlist (read)
   - Autotrax (protel) pcb boards (read, write)
   - Eagle XML format boards and libraries (read)
   - Eagle binary format boards and libraries (read)
   - Eagle DRU files (read)
   - Mentor Graphics Hyperlynx (read/write)
   - gEDA/PCB (read, write)
   - Specctra DSN (partial import/export, for freerouting.net)
   - flat EDIF netlist (import)
   - HPGL plot files (import)
   - openSCAD colored 3d model script (export)
   - ltspice netlist+footprint info (import)
   - Mentor Graphics Design Capture netlist+footprint info (import)
   - MUCS unixplot (partial import: lines, vias)
   - gEDA/gschem netlist+footprint info (import)
   - TinyCAD netlist+footprint info (import)
   - breadboard assembly drawing png (export)
   - BoM (Bill of Materials; export)
   - dxf, 2d drawings (export)
   - fidocadj board (export)
   - gcode (export)
   - PNG, JPEG, GIF (export with photo-realistic render option)
   - postscript: ps, eps (export)
   - svg (export)
   - xy: template based, multi-format footprint/coord list (export)

Package: pcb-rnd-debug
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Debug and diagnostics.
 Extra action commands to help debugging and diagnostize problems and
 bugs.

Package: pcb-rnd-export
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Common export plugins.
 Export the board in vector graphics (svg, ps, eps), raster graphics
 (png, jpeg, etc.), gerber, 3d model in openscad, xy for pick and
 place, BoM, etc.

Package: pcb-rnd-doc
Architecture: all
Replaces: pcb-rnd (<< 2.2.0-2)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Documentation for pcb-rnd
 User manual (html) and manual pages.

Package: pcb-rnd-export-sim
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Export plugins to simulators
 Export the board in formats that can be used for simulation: openems.

Package: pcb-rnd-lib-gl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Support library for rendering with opengl.
 Provides plugins for driving an opengl output, rendering pcb-rnd
 views on opengl.

Package: pcb-rnd-import-geo
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Geometry import plugins.
 Import geometry from HPGL plots. HPGL can be produced (plotted) with
 most mechanical cads.

Package: pcb-rnd-hid-gtk2-gl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-gtk, pcb-rnd-lib-gl
Description: GUI: gtk2, opengl
 Hardware accelerated (opengl) rendering on gtk2.

Package: pcb-rnd-import-net
Architecture: any
Replaces: pcb-rnd (<< 2.2.0-2)
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-io
Description: Netlist/schematics import plugins.
 Import netlist and footprint information from edif, ltspice, mentor
 graphics, gschem and tinycad.

Package: librnd-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, librnd2 (= ${binary:Version}), pcb-rnd-core
Description: pcb-rnd library, headers.
 HID, polygons, infrastructure for 3rd party applications.

Package: pcb-rnd-auto
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-io
Description: Autoroute and autoplace.
 Feature plugins for automated component placing and track routing

Package: pcb-rnd-lib-io
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Support library for alien file formats.
 Provides generic, low level parsers (such as s-expression parser) for
 I/O plugins that need to deal with alien file formats.

Package: pcb-rnd-io-standard
Architecture: any
Replaces: pcb-rnd (<< 2.2.0-2)
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-io
Description: Commonly used non-native board and footprint file formats
 Plugins for tEDAx footprint format and the gEDA/PCB file formats
 (footprint and board).

Package: pcb-rnd-lib-gui
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Support library for building the GUI.
 Provides pcb-rnd specific dialog boxes (e.g. fontsel) and top window
 GUI elements.

Package: pcb-rnd-core
Architecture: any
Replaces: pcb-rnd (<< 2.2.0-2)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: pcb-rnd executable with the core functionality
 Includes the data model, the most common action commands, the native
 file format and the CLI (batch HID). Does not contain GUI. Can be
 used in headless mode or batch/scripted mode for automated processing.

Package: pcb-rnd-lib-gtk
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-gui
Description: Support library for building the GUI with gtk.
 Provides the common gtk code (e.g. dialog box engine, input handling)
 for any gtk based HID plugin.

Package: pcb-rnd-hid-lesstif
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-gui
Description: GUI: motif/lesstif, software render
 Lightweight GUI and software rendering using the motif (lesstif)
 toolkit.

Package: librnd2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: pcb-rnd library, binaries.
 HID, polygons, infrastructure for 3rd party applications.

Package: pcb-rnd-io-alien
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-io
Description: File format compatibility with other PCB layout designers.
 Load and/or save boards in file formats supported by other EDA tools,
 such as KiCAD, Eagle, protel/autotrax, etc.

Package: pcb-rnd-cloud
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, wget, pcb-rnd-core
Description: Networking plugins.
 'Cloud' footprint access plugin that integrates edakrill and
 gedasymbols.org.

Package: pcb-rnd-export-extra
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-export
Description: Export formats: special/extra
 Less commonly used export formats: fidocadj, ipc-356-d, direct
 printing with lpr.

Package: pcb-rnd-hid-gtk2-gdk
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core, pcb-rnd-lib-gtk
Description: GUI: gtk2, software render
 Software rendering on gtk2, using the gdk API.

Package: pcb-rnd-extra
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, pcb-rnd-core
Description: Extra action commands and optional functionality.
 Align objects in grid, optimize tracks, font editor, combine
 polygons, renumber subcircuits, apply vendor drill mapping.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
ifeq (mipsel,$(findstring mipsel,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else ifeq (mips64el,$(findstring mips64el,$(DEB_HOST_ARCH)))
	dh $@ --no-parallel
else
	dh $@
endif

override_dh_auto_clean:
	# only try to run dh_auto_clean if configure has been run
	test -f Makefile.conf && dh_auto_clean || true

override_dh_auto_configure:
	./configure \
		--LDFLAGS='$(LDFLAGS)' \
		--CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
		\
		--symbols \
		--prefix=/usr \
		--confdir=/etc/pcb-rnd \
		--prefix/libs/script/fungw=/dev/null \
		\
		--all=disable \
		--buildin-script \
		--buildin-fp_fs \
		--buildin-draw_fab \
		--buildin-act_read \
		--buildin-mincut \
		--buildin-report \
		--buildin-rubberband_orig \
		--buildin-exto_std \
		--buildin-fp_board \
		--buildin-propedit \
		--buildin-io_lihata \
		--buildin-autocrop \
		--buildin-lib_polyhelp \
		--buildin-draw_csect \
		--buildin-ddraft \
		--buildin-hid_batch \
		--buildin-act_draw \
		--buildin-query \
		--buildin-lib_compat_help \
		--buildin-drc_orig \
		--buildin-shape \
		--buildin-extedit \
		--plugin-export_excellon \
		--plugin-export_fidocadj \
		--plugin-export_lpr \
		--plugin-export_oldconn \
		--plugin-import_pxm_gd \
		--plugin-export_stat \
		--plugin-io_kicad_legacy \
		--plugin-io_eagle \
		--plugin-io_tedax \
		--plugin-import_pxm_pnm \
		--plugin-io_kicad \
		--plugin-import_mucs \
		--plugin-renumber \
		--plugin-import_calay \
		--plugin-smartdisperse \
		--plugin-draw_fontsel \
		--plugin-polycombine \
		--plugin-export_gcode \
		--plugin-export_bom \
		--plugin-ar_cpcb \
		--plugin-lib_hid_pcbui \
		--plugin-import_sch \
		--plugin-teardrops \
		--plugin-shand_cmd \
		--plugin-import_tinycad \
		--plugin-export_openems \
		--plugin-import_ltspice \
		--plugin-export_dxf \
		--plugin-lib_gtk_common \
		--plugin-export_ipcd356 \
		--plugin-import_ttf \
		--plugin-import_mentor_sch \
		--plugin-import_dsn \
		--plugin-export_ps \
		--plugin-hid_gtk2_gdk \
		--plugin-millpath \
		--plugin-djopt \
		--plugin-hid_gtk2_gl \
		--plugin-import_edif \
		--plugin-hid_lesstif \
		--plugin-lib_gensexpr \
		--plugin-diag \
		--plugin-lib_wget \
		--plugin-lib_hid_gl \
		--plugin-export_stl \
		--plugin-autoplace \
		--plugin-export_svg \
		--plugin-fp_wget \
		--plugin-fontmode \
		--plugin-import_netlist \
		--plugin-polystitch \
		--plugin-dialogs \
		--plugin-io_dsn \
		--plugin-export_xy \
		--plugin-import_hpgl \
		--plugin-export_png \
		--plugin-import_ipcd356 \
		--plugin-distaligntext \
		--plugin-export_dsn \
		--plugin-lib_netmap \
		--plugin-lib_hid_common \
		--plugin-io_hyp \
		--plugin-cam \
		--plugin-puller \
		--plugin-import_fpcb_nl \
		--plugin-io_pcb \
		--plugin-distalign \
		--plugin-asm \
		--plugin-export_openscad \
		--plugin-jostle \
		--plugin-autoroute \
		--plugin-io_autotrax \
		--plugin-vendordrill \
		--plugin-export_gerber \

=== debian/watch ===
version=3
opts=dversionmangle=s/\+repack.*$// \
  http://repo.hu/projects/pcb-rnd/releases/pcb-rnd-(.*)\.tar\.gz
